module gcc.config.unix;
private import gcc.config.config;
private import gcc.config.libc;
struct dirent
{
    ubyte[6] __pad1;
    char d_type;
    ubyte[1] __pad2;
    char[256] d_name;
}

alias void DIR;
enum
{
  DT_WHT = 14,
  DT_SOCK = 12,
  DT_BLK = 6,
  DT_CHR = 2,
  DT_REG = 8,
  DT_UNKNOWN = 0,
  DT_DIR = 4,
  DT_LNK = 10,
  DT_FIFO = 1,
}

const int PATH_MAX = 1024;
const int NFDBITS = 32;
const int FD_SETSIZE = 1024;
struct fd_set
{
    byte[128] __opaque;
}

alias ushort mode_t;
alias int pid_t;
alias uint uid_t;
alias uint gid_t;
alias long off_t;
alias int ssize_t;
enum
{
  O_NOCTTY = 32768,
  O_ACCMODE = 3,
  O_APPEND = 8,
  O_EXLOCK = 32,
  O_NDELAY = 4,
  O_WRONLY = 1,
  O_FSYNC = 128,
  O_NONBLOCK = 4,
  O_RSYNC = 128,
  O_DSYNC = 128,
  O_RDWR = 2,
  O_SYNC = 128,
  O_CREAT = 512,
  O_DIRECT = 65536,
  O_ASYNC = 64,
  O_LARGEFILE = 0,
  O_SHLOCK = 16,
  O_RDONLY = 0,
  O_TRUNC = 1024,
  O_EXCL = 2048,
  O_NOFOLLOW = 256,
}

enum
{
  F_RDLCK = 1,
  F_GETLK = 7,
  F_DUPFD = 0,
  F_UNLCK = 2,
  F_GETFL = 3,
  F_LOCK = 1,
  F_SETLKW64 = 9,
  F_SETOWN = 5,
  F_ULOCK = 0,
  F_SETFL = 4,
  F_GETOWN = 6,
  F_SETLK = 8,
  F_SETLK64 = 8,
  F_TLOCK = 2,
  F_TEST = 3,
  F_WRLCK = 3,
  F_GETLK64 = 7,
  F_SETLKW = 9,
  F_GETFD = 1,
  F_SETFD = 2,
}

enum
{
  F_OK = 0,
  W_OK = 2,
  R_OK = 4,
  X_OK = 1,
}

struct timespec
{
    int tv_sec;
    int tv_nsec;
}

struct timeval
{
    int tv_sec;
    int tv_usec;
}

struct timezone
{
    int tz_minuteswest;
    int tz_dsttime;
}

alias int clockid_t;
struct utimbuf
{
    int actime;
    int modtime;
}

enum
{
  S_IFSOCK = 49152,
  S_IFBLK = 24576,
  S_IXOTH = 1,
  S_IREAD = 256,
  S_IRWXG = 56,
  S_IRWXO = 7,
  S_IRWXU = 448,
  S_IFMT = 61440,
  S_IFCHR = 8192,
  S_IWUSR = 128,
  S_IFREG = 32768,
  S_IWRITE = 128,
  S_IWGRP = 16,
  S_IRUSR = 256,
  S_IFDIR = 16384,
  S_ISVTX = 512,
  S_IEXEC = 64,
  S_IXUSR = 64,
  S_IWOTH = 2,
  S_IRGRP = 32,
  S_IFLNK = 40960,
  S_ISGID = 1024,
  S_IXGRP = 8,
  S_ISUID = 2048,
  S_IROTH = 4,
  S_IFIFO = 4096,
}

struct struct_stat
{
    uint st_dev;
    uint st_ino;
    ushort st_mode;
    ubyte[2] __pad1;
    ushort st_nlink;
    ubyte[2] __pad2;
    uint st_uid;
    uint st_gid;
    uint st_rdev;
    int st_atime;
    ubyte[4] __pad3;
    int st_mtime;
    ubyte[4] __pad4;
    int st_ctime;
    ubyte[4] __pad5;
    long st_size;
    long st_blocks;
    uint st_blksize;
   ubyte[24] __pad6;
}

enum
{
  SIGBUS = 10,
  SIGTTIN = 21,
  SIGTTOU = 22,
  SIGPROF = 27,
  SIGALRM = 14,
  SIGFPE = 8,
  SIGUSR1 = 30,
  SIGURG = 16,
  SIGIO = 23,
  SIGQUIT = 3,
  SIGPOLL = 23,
  SIGEV_NONE = 0,
  SIGCLD = 20,
  SIGABRT = 6,
  SIGSTKSZ = 40960,
  SIGINFO = 29,
  SIGTRAP = 5,
  SIGEV_THREAD = 2,
  SIGVTALRM = 26,
  SIGSEGV = 11,
  SIGCONT = 19,
  SIGPIPE = 13,
  SIGWINCH = 28,
  SIGXFSZ = 25,
  SIGHUP = 1,
  SIGCHLD = 20,
  SIGSYS = 12,
  SIGSTOP = 17,
  SIGUSR2 = 31,
  SIGTSTP = 18,
  SIGEMT = 7,
  SIGKILL = 9,
  SIGXCPU = 24,
  SIGEV_SIGNAL = 1,
  SIGILL = 4,
  SIGINT = 2,
  SIGIOT = 6,
  SIGTERM = 15,
}

enum
{
  SA_SIGINFO = 64,
  SA_ONSTACK = 1,
  SA_NODEFER = 16,
  SA_RESETHAND = 4,
  SA_NOMASK = 16,
  SA_NOCLDSTOP = 8,
  SA_INTERRUPT = 0,
  SA_STACK = 1,
  SA_ONESHOT = 4,
  SA_RESTART = 2,
  SA_NOCLDWAIT = 32,
}

struct sigset_t
{
    byte[16] __opaque;
}

alias extern(C) void function(int) __sighandler_t;
const __sighandler_t SIG_DFL = cast(__sighandler_t) 0;
const __sighandler_t SIG_IGN = cast(__sighandler_t) 1;
const __sighandler_t SIG_ERR = cast(__sighandler_t) 4294967295;
struct siginfo_t
{
    int si_signo;
    int si_errno;
    int si_code;
   ubyte[52] __pad1;
}

struct sigaction_t
{
    union {
        extern(C) void function(int) sa_handler;
        extern(C) void function(int, siginfo_t *, void *) sa_sigaction;
    }
    int sa_flags;
    sigset_t sa_mask;
}

const void * MAP_FAILED = cast(void *) 4294967295;
enum
{
  PROT_NONE = 0,
  PROT_WRITE = 2,
  PROT_READ = 1,
  PROT_EXEC = 4,
}

enum
{
  MAP_TYPE = 4096,
  MAP_NOSYNC = 2048,
  MAP_RENAME = 32,
  MAP_PRIVATE = 2,
  MAP_COPY = 2,
  MAP_ANON = 4096,
  MAP_HASSEMPHORE = 512,
  MAP_FILE = 0,
  MAP_FIXED = 16,
  MAP_STACK = 1024,
  MAP_NORESERVE = 64,
  MAP_RESERVED0080 = 128,
  MAP_NOCORE = 131072,
  MAP_SHARED = 1,
  MAP_RESERVED0100 = 256,
  MAP_ANONYMOUS = 4096,
}

enum
{
  MS_ASYNC = 1,
  MS_SYNC = 0,
  MS_INVALIDATE = 2,
}

enum
{
  MCL_FUTURE = 2,
  MCL_CURRENT = 1,
}

enum
{
  MADV_NORMAL = 0,
  MADV_AUTOSYNC = 7,
  MADV_NOCORE = 8,
  MADV_WILLNEED = 3,
  MADV_FREE = 5,
  MADV_DONTNEED = 4,
  MADV_CORE = 9,
  MADV_SEQUENTIAL = 2,
  MADV_RANDOM = 1,
  MADV_PROTECT = 10,
  MADV_NOSYNC = 6,
}

struct sem_t
{
    byte[16] __opaque;
}

alias uint pthread_t;
struct pthread_attr_t
{
    byte[36] __opaque;
}

struct pthread_cond_t
{
    byte[48] __opaque;
}

struct pthread_condattr_t
{
    byte[4] __opaque;
}

struct pthread_mutex_t
{
    byte[24] __opaque;
}

struct pthread_mutexattr_t
{
    byte[4] __opaque;
}

struct sched_param
{
    int sched_priority;
}

struct pthread_barrier_t
{
    byte[20] __opaque;
}

struct pthread_barrierattr_t
{
    byte[4] __opaque;
}

struct pthread_rwlock_t
{
    byte[32] __opaque;
}

struct pthread_rwlockattr_t
{
    byte[8] __opaque;
}

alias int pthread_spinlock_t;
enum
{
  PTHREAD_CANCEL_DEFERRED = 0,
  PTHREAD_CANCEL_ASYNCHRONOUS = 1,
  PTHREAD_CANCEL_ENABLE = 0,
  PTHREAD_CANCEL_DISABLE = 1,
}

alias uint socklen_t;
enum
{
  SOL_IPV6 = 41,
  SOL_TCP = 6,
  SOL_IP = 0,
  SOL_ICMPV6 = 58,
  SOL_SOCKET = 65535,
}

enum
{
  SO_KEEPALIVE = 8,
  SO_REUSEADDR = 4,
  SO_USELOOPBACK = 64,
  SO_STYLE = 4104,
  SO_LINGER = 128,
  SO_BROADCAST = 32,
  SO_ACCEPTCONN = 2,
  SO_TYPE = 4104,
  SO_DONTROUTE = 16,
  SO_RCVLOWAT = 4100,
  SO_SNDTIMEO = 4101,
  SO_OOBINLINE = 256,
  SO_REUSEPORT = 512,
  SO_TIMESTAMP = 1024,
  SO_SNDBUF = 4097,
  SO_DEBUG = 1,
  SO_RCVBUF = 4098,
  SO_SNDLOWAT = 4099,
  SO_ERROR = 4103,
  SO_RCVTIMEO = 4102,
}

enum
{
  SOCK_RAW = 3,
  SOCK_RDM = 4,
  SOCK_SEQPACKET = 5,
  SOCK_DGRAM = 2,
  SOCK_STREAM = 1,
}

enum
{
  MSG_NOSIGNAL = 131072,
  MSG_WAITALL = 64,
  MSG_PEEK = 2,
  MSG_CTRUNC = 32,
  MSG_DONTROUTE = 4,
  MSG_COMPAT = 32768,
  MSG_NOTIFICATION = 8192,
  MSG_NBIO = 16384,
  MSG_TRUNC = 16,
  MSG_OOB = 1,
  MSG_DONTWAIT = 128,
  MSG_EOF = 256,
  MSG_EOR = 8,
}

static if (!is(typeof(MSG_NOSIGNAL))) enum { MSG_NOSIGNAL = 0 } // for std/socket.d
enum
{
  AF_MAX = 33,
  AF_APPLETALK = 16,
  AF_NS = 6,
  AF_E164 = 26,
  AF_ECMA = 8,
  AF_FILE = 1,
  AF_COIP = 20,
  AF_INET6 = 28,
  AF_UNSPEC = 0,
  AF_ROUTE = 17,
  AF_SIP = 24,
  AF_LINK = 18,
  AF_CHAOS = 5,
  AF_IMPLINK = 3,
  AF_INET = 2,
  AF_DLI = 13,
  AF_OSI = 7,
  AF_DATAKIT = 9,
  AF_NETGRAPH = 32,
  AF_SNA = 11,
  AF_LAT = 14,
  AF_ISO = 7,
  AF_LOCAL = 1,
  AF_CNT = 21,
  AF_HYLINK = 15,
  AF_ATM = 30,
  AF_CCITT = 10,
  AF_NATM = 29,
  AF_UNIX = 1,
  AF_DECnet = 12,
  AF_PUP = 4,
  AF_ISDN = 26,
  AF_IPX = 23,
}

enum
{
  PF_DECnet = 12,
  PF_COIP = 20,
  PF_CCITT = 10,
  PF_SIP = 24,
  PF_SNA = 11,
  PF_NATM = 29,
  PF_UNIX = 1,
  PF_ATM = 30,
  PF_NETGRAPH = 32,
  PF_ISDN = 26,
  PF_PUP = 4,
  PF_LAT = 14,
  PF_UNSPEC = 0,
  PF_IPX = 23,
  PF_ISO = 7,
  PF_MAX = 33,
  PF_OSI = 7,
  PF_INET6 = 28,
  PF_FILE = 1,
  PF_ECMA = 8,
  PF_HDRCMPLT = 31,
  PF_XTP = 19,
  PF_ROUTE = 17,
  PF_DATAKIT = 9,
  PF_LINK = 18,
  PF_PIP = 25,
  PF_DLI = 13,
  PF_CNT = 21,
  PF_RTIP = 22,
  PF_IMPLINK = 3,
  PF_APPLETALK = 16,
  PF_KEY = 27,
  PF_INET = 2,
  PF_CHAOS = 5,
  PF_HYLINK = 15,
  PF_NS = 6,
  PF_LOCAL = 1,
}

struct linger
{
    int l_onoff;
    int l_linger;
}

enum
{
  IPPROTO_ROUTING = 43,
  IPPROTO_DIVERT = 258,
  IPPROTO_EGP = 8,
  IPPROTO_PIM = 103,
  IPPROTO_ENCAP = 98,
  IPPROTO_ESP = 50,
  IPPROTO_PUP = 12,
  IPPROTO_IDP = 22,
  IPPROTO_IPIP = 4,
  IPPROTO_TCP = 6,
  IPPROTO_IPV6 = 41,
  IPPROTO_SCTP = 132,
  IPPROTO_RSVP = 46,
  IPPROTO_AH = 51,
  IPPROTO_IP = 0,
  IPPROTO_MTP = 92,
  IPPROTO_TP = 29,
  IPPROTO_UDP = 17,
  IPPROTO_HOPOPTS = 0,
  IPPROTO_RAW = 255,
  IPPROTO_ICMP = 1,
  IPPROTO_GGP = 3,
  IPPROTO_FRAGMENT = 44,
  IPPROTO_GRE = 47,
  IPPROTO_DSTOPTS = 60,
  IPPROTO_NONE = 59,
  IPPROTO_IGMP = 2,
  IPPROTO_ICMPV6 = 58,
  IPPROTO_COMP = 108,
  IPPROTO_DCCP = 33,
  IPPROTO_UDPLITE = 136,
}

enum
{
  IPV6_RTHDR_TYPE_0 = 0,
  IPV6_LEAVE_GROUP = 13,
  IPV6_SOCKOPT_RESERVED1 = 3,
  IPV6_FW_FLUSH = 32,
  IPV6_PATHMTU = 44,
  IPV6_CHECKSUM = 26,
  IPV6_NEXTHOP = 48,
  IPV6_DEFAULT_MULTICAST_LOOP = 1,
  IPV6_HOPOPTS = 49,
  IPV6_IPSEC_POLICY = 28,
  IPV6_FAITH = 29,
  IPV6_FW_GET = 34,
  IPV6_ADD_MEMBERSHIP = 12,
  IPV6_RECVPATHMTU = 43,
  IPV6_PORTRANGE_HIGH = 1,
  IPV6_DSTOPTS = 50,
  IPV6_USE_MIN_MTU = 42,
  IPV6_RECVHOPOPTS = 39,
  IPV6_RXHOPOPTS = 49,
  IPV6_PORTRANGE = 14,
  IPV6_UNICAST_HOPS = 4,
  IPV6_PORTRANGE_DEFAULT = 0,
  IPV6_FW_DEL = 31,
  IPV6_V6ONLY = 27,
  IPV6_RECVRTHDR = 38,
  IPV6_RECVHOPLIMIT = 37,
  IPV6_RECVTCLASS = 57,
  IPV6_DEFAULT_MULTICAST_HOPS = 1,
  IPV6_RECVDSTOPTS = 40,
  IPV6_MULTICAST_IF = 9,
  IPV6_RXDSTOPTS = 50,
  IPV6_AUTOFLOWLABEL = 59,
  IPV6_MULTICAST_HOPS = 10,
  IPV6_HOPLIMIT = 47,
  IPV6_FW_ADD = 30,
  IPV6_PKTINFO = 46,
  IPV6_PREFER_TEMPADDR = 63,
  IPV6_RTHDRDSTOPTS = 35,
  IPV6_TCLASS = 61,
  IPV6_FW_ZERO = 33,
  IPV6_RTHDR_LOOSE = 0,
  IPV6_JOIN_GROUP = 12,
  IPV6_RTHDR = 51,
  IPV6_DONTFRAG = 62,
  IPV6_RECVPKTINFO = 36,
  IPV6_DROP_MEMBERSHIP = 13,
  IPV6_PORTRANGE_LOW = 2,
  IPV6_MULTICAST_LOOP = 11,
  IPV6_RTHDR_STRICT = 1,
}

enum : uint
{
  INADDR_ALLRTRS_GROUP = -536870910,
  INADDR_MAX_LOCAL_GROUP = -536870657,
  INADDR_ANY = 0,
  INADDR_UNSPEC_GROUP = -536870912,
  INADDR_ALLHOSTS_GROUP = -536870911,
  INADDR_NONE = -1,
  INADDR_LOOPBACK = 2130706433,
  INADDR_BROADCAST = -1,
}

enum { ADDR_ANY = INADDR_ANY }
enum
{
  TCP_CONGESTION = 64,
  TCP_MAXBURST = 4,
  TCP_MAXOLEN = 40,
  TCP_MSS = 512,
  TCP_MAX_SACK = 4,
  TCP_MAX_WINSHIFT = 14,
  TCP_NOPUSH = 4,
  TCP_MAXSEG = 2,
  TCP_MAXHLEN = 60,
  TCP_MAXWIN = 65535,
  TCP_INFO = 32,
  TCP_MD5SIG = 16,
  TCP_NOOPT = 8,
  TCP_NODELAY = 1,
}

struct in_addr
{
    uint s_addr;
}

struct sockaddr
{
    ubyte sa_len;
    ubyte sa_family;
    byte[14] sa_data;
}

struct sockaddr_in
{
    ubyte sin_len = sockaddr_in.sizeof;
    ubyte sin_family = AF_INET;
    ushort sin_port;
    in_addr sin_addr;
    ubyte[8] sin_zero;
}

struct protoent
{
    char* p_name;
    char** p_aliases;
    int p_proto;
}

struct servent
{
    char* s_name;
    char** s_aliases;
    int s_port;
    char* s_proto;
}

struct hostent
{
    char* h_name;
    char** h_aliases;
    int h_addrtype;
    int h_length;
    char** h_addr_list;

  char* h_addr()
  {
      return h_addr_list[0];
  }

}

struct addrinfo { }
struct passwd
{
    char* pw_name;
    char* pw_passwd;
    uint pw_uid;
    uint pw_gid;
    char* pw_gecos;
    char* pw_dir;
    char* pw_shell;
}

